/*
 * generated by Xtext 2.18.0
 */
grammar DebugInternalProtelis;

// Rule ProtelisModule
ruleProtelisModule:
	(
		(
			('module')=>
			'module'
		)
		ruleProtelisQualifiedName
	)?
	(
		(ruleImportSection
		)=>
		ruleImportSection
	)?
	(
		(ruleFunctionDef
		)=>
		ruleFunctionDef
	)*
	ruleBlock
	?
;

// Rule ImportSection
ruleImportSection:
	(
		(ruleImportDeclaration
		)=>
		ruleImportDeclaration
	)+
;

// Rule ImportDeclaration
ruleImportDeclaration:
	(
		(
			(ruleProtelisImport
			)=>
			ruleProtelisImport
		)
		    |
		ruleJavaImport
	)
;

// Rule JavaImport
ruleJavaImport:
	'import'
	ruleQualifiedNameInStaticImport
	(
		'*'
		    |
		ruleAID
	)
;

// Rule ProtelisImport
ruleProtelisImport:
	'import'
	ruleProtelisQualifiedName
;

// Rule ProtelisQualifiedName
ruleProtelisQualifiedName:
	RULE_ID
	(
		':'
		RULE_ID
	)*
;

// Rule FunctionDef
ruleFunctionDef:
	'public'
	?
	'def'
	RULE_ID
	'('
	ruleVarDefList
	?
	')'
	(
		'{'
		ruleBlock
		'}'
		    |
		'='
		ruleExpression
	)
;

// Rule VarDefList
ruleVarDefList:
	ruleVarDef
	(
		','
		ruleVarDef
	)*
;

// Rule VarDef
ruleVarDef:
	RULE_ID
;

// Rule Block
ruleBlock:
	(
		ruleStatement
		';'*
	)+
;

// Rule Statement
ruleStatement:
	(
		(
			(ruleDeclaration)=>
			ruleDeclaration
		)
		    |
		(
			(ruleAssignment)=>
			ruleAssignment
		)
		    |
		(
			(ruleExpression)=>
			ruleExpression
		)
		    |
		ruleIfWithoutElse
	)
;

// Rule Declaration
ruleDeclaration:
	'let'
	ruleVarDef
	'='
	ruleExpression
;

// Rule Assignment
ruleAssignment:
	RULE_ID
	'='
	ruleExpression
;

// Rule IfWithoutElse
ruleIfWithoutElse:
	'if'
	'('
	ruleExpression
	')'
	'{'
	(
		ruleStatement
		(
			';'
			ruleStatement
		)*
	)?
	'}'
;

// Rule Expression
ruleExpression:
	ruleLogicalOr
;

// Rule LogicalOr
ruleLogicalOr:
	ruleLogicalAnd
	(
		'||'
		ruleLogicalAnd
	)*
;

// Rule LogicalAnd
ruleLogicalAnd:
	ruleEquality
	(
		'&&'
		ruleEquality
	)*
;

// Rule Equality
ruleEquality:
	ruleRelational
	(
		(
			'=='
			    |
			'!='
		)
		ruleRelational
	)*
;

// Rule Relational
ruleRelational:
	ruleAddition
	(
		(
			'>'
			    |
			'>='
			    |
			'<'
			    |
			'<='
		)
		ruleAddition
	)*
;

// Rule Addition
ruleAddition:
	ruleMultiplication
	(
		((
			'+'
			    |
			'-'
		)
		ruleMultiplication
		)=>
		(
			'+'
			    |
			'-'
		)
		ruleMultiplication
	)*
;

// Rule Multiplication
ruleMultiplication:
	rulePower
	(
		(
			'*'
			    |
			'/'
			    |
			'%'
		)
		rulePower
	)*
;

// Rule Power
rulePower:
	rulePrefix
	(
		'^'
		rulePrefix
	)*
;

// Rule Prefix
rulePrefix:
	(
		rulePostfix
		    |
		(
			'!'
			    |
			'-'
		)
		rulePostfix
	)
;

// Rule Postfix
rulePostfix:
	rulePrimary
	(
		((
			'.'
			ruleMethodCall
			    |
			ruleInvocationArguments
		)
		)=>
		(
			'.'
			ruleMethodCall
			    |
			ruleInvocationArguments
		)
	)*
;

// Rule MethodCall
ruleMethodCall:
	ruleAID
	ruleInvocationArguments
;

// Rule Primary
rulePrimary:
	(
		(
			(ruleRep)=>
			ruleRep
		)
		    |
		(
			(ruleShare)=>
			ruleShare
		)
		    |
		(
			(ruleNBR)=>
			ruleNBR
		)
		    |
		(
			(ruleIf)=>
			ruleIf
		)
		    |
		(
			(ruleLambda)=>
			ruleLambda
		)
		    |
		(
			(ruleBuiltin)=>
			ruleBuiltin
		)
		    |
		ruleVarUse
		    |
		ruleScalar
		    |
		'('
		ruleExpression
		')'
	)
;

// Rule CallRule
ruleCallRule:
	ruleAID
	(
		ruleJCallElement+
		    |
		ruleProtelisCallElement+
	)?
;

// Rule JCallElement
ruleJCallElement:
	'::'
	ruleAID
;

// Rule ProtelisCallElement
ruleProtelisCallElement:
	':'
	RULE_ID
;

// Rule InvocationArguments
ruleInvocationArguments:
	(
		(
			('('
			ruleExpressionList
			?
			')'
			ruleKotlinStyleLambda
			)=>
			'('
			ruleExpressionList
			?
			')'
			ruleKotlinStyleLambda
		)
		    |
		'('
		ruleExpressionList
		?
		')'
		    |
		ruleKotlinStyleLambda
	)
;

// Rule ExpressionList
ruleExpressionList:
	ruleExpression
	(
		','
		ruleExpression
	)*
;

// Rule Lambda
ruleLambda:
	(
		ruleKotlinStyleLambda
		    |
		ruleOldLambda
	)
;

// Rule KotlinStyleLambda
ruleKotlinStyleLambda:
	(
		(
			(ruleLongLambda)=>
			ruleLongLambda
		)
		    |
		ruleShortLambda
	)
;

// Rule LongLambda
ruleLongLambda:
	'{'
	ruleVarDefList
	'->'
	ruleBlock
	'}'
;

// Rule ShortLambda
ruleShortLambda:
	'{'
	ruleBlock
	'}'
;

// Rule OldLambda
ruleOldLambda:
	(
		(
			(ruleOldLongLambda)=>
			ruleOldLongLambda
		)
		    |
		ruleOldShortLambda
	)
;

// Rule OldShortLambda
ruleOldShortLambda:
	ruleVarDef
	'->'
	'{'
	ruleBlock
	'}'
;

// Rule OldLongLambda
ruleOldLongLambda:
	'('
	ruleVarDefList
	?
	')'
	'->'
	'{'
	ruleBlock
	'}'
;

// Rule Rep
ruleRep:
	'rep'
	'('
	ruleRepInitialize
	')'
	'{'
	ruleBlock
	'}'
	ruleYield
	?
;

// Rule RepInitialize
ruleRepInitialize:
	ruleVarDef
	'<-'
	ruleExpression
;

// Rule Share
ruleShare:
	'share'
	'('
	ruleShareInitialize
	')'
	'{'
	ruleBlock
	'}'
	ruleYield
	?
;

// Rule ShareInitialize
ruleShareInitialize:
	(
		ruleVarDef
		','
	)?
	ruleVarDef
	'<-'
	ruleExpression
;

// Rule Yield
ruleYield:
	'yield'
	'{'
	ruleBlock
	'}'
;

// Rule NBR
ruleNBR:
	'nbr'
	'('
	ruleExpression
	')'
;

// Rule If
ruleIf:
	'if'
	'('
	ruleExpression
	')'
	'{'
	ruleBlock
	'}'
	'else'
	'{'
	ruleBlock
	'}'
;

// Rule VarUse
ruleVarUse:
	ruleCallRule
;

// Rule Scalar
ruleScalar:
	(
		ruleDoubleVal
		    |
		ruleStringVal
		    |
		ruleBooleanVal
		    |
		ruleTupleVal
	)
;

// Rule Builtin
ruleBuiltin:
	(
		ruleSelf
		    |
		ruleEnv
		    |
		ruleIt
		    |
		ruleEval
		    |
		ruleAlignedMap
		    |
		ruleMux
		    |
		ruleHood
	)
;

// Rule Self
ruleSelf:
	'self'
;

// Rule Env
ruleEnv:
	'env'
;

// Rule It
ruleIt:
	'it'
;

// Rule Eval
ruleEval:
	'eval'
	'('
	ruleExpression
	')'
;

// Rule AlignedMap
ruleAlignedMap:
	'alignedMap'
	'('
	ruleExpression
	','
	ruleExpression
	','
	ruleExpression
	','
	ruleExpression
	')'
;

// Rule Mux
ruleMux:
	'mux'
	'('
	ruleExpression
	')'
	'{'
	ruleBlock
	'}'
	'else'
	'{'
	ruleBlock
	'}'
;

// Rule Hood
ruleHood:
	(
		ruleBuiltinHoodOp
		    |
		ruleGenericHood
	)
;

// Rule GenericHood
ruleGenericHood:
	(
		'hood'
		    |
		'hoodPlusSelf'
	)
	'('
	(
		ruleVarUse
		    |
		ruleLambda
	)
	','
	ruleExpression
	','
	ruleExpression
	')'
;

// Rule BuiltinHoodOp
ruleBuiltinHoodOp:
	ruleBuiltinHood
	'PlusSelf'
	?
	'('
	ruleExpression
	')'
;

// Rule BuiltinHood
ruleBuiltinHood:
	(
		'minHood'
		    |
		'maxHood'
		    |
		'localHood'
		    |
		'anyHood'
		    |
		'allHood'
		    |
		'sumHood'
		    |
		'meanHood'
		    |
		'unionHood'
	)
;

// Rule DoubleVal
ruleDoubleVal:
	ruleDOUBLE
;

// Rule StringVal
ruleStringVal:
	RULE_STRING
;

// Rule BooleanVal
ruleBooleanVal:
	ruleBOOLEAN
;

// Rule TupleVal
ruleTupleVal:
	'['
	ruleExpressionList
	?
	']'
;

// Rule AID
ruleAID:
	(
		(
			(RULE_ID)=>
			RULE_ID
		)
		    |
		rulePROTELIS_KEYWORD
	)
;

// Rule PROTELIS_KEYWORD
rulePROTELIS_KEYWORD:
	(
		'module'
		    |
		'def'
		    |
		'let'
		    |
		'rep'
		    |
		'share'
		    |
		'nbr'
		    |
		ruleBuiltinHood
		    |
		'PlusSelf'
		    |
		'hood'
		    |
		'hoodPlusSelf'
		    |
		'self'
		    |
		'env'
		    |
		'it'
		    |
		'mux'
		    |
		'eval'
	)
;

// Rule QualifiedNameInStaticImport
ruleQualifiedNameInStaticImport:
	(
		ruleAID
		'.'
	)+
;

// Rule DOUBLE
ruleDOUBLE:
	RULE_INT
	(
		'.'
		RULE_INT
	)?
	(
		'e'
		    |
		'E'
		'-'?
		RULE_INT
	)?
;

// Rule BOOLEAN
ruleBOOLEAN:
	(
		'true'
		    |
		'false'
	)
;

// Rule JvmTypeReference
ruleJvmTypeReference:
	(
		ruleJvmParameterizedTypeReference
		(
			(ruleArrayBrackets
			)=>
			ruleArrayBrackets
		)*
		    |
		ruleXFunctionTypeRef
	)
;

// Rule ArrayBrackets
ruleArrayBrackets:
	'['
	']'
;

// Rule XFunctionTypeRef
ruleXFunctionTypeRef:
	(
		'('
		(
			ruleJvmTypeReference
			(
				','
				ruleJvmTypeReference
			)*
		)?
		')'
	)?
	'=>'
	ruleJvmTypeReference
;

// Rule JvmParameterizedTypeReference
ruleJvmParameterizedTypeReference:
	ruleQualifiedName
	(
		(
			('<')=>
			'<'
		)
		ruleJvmArgumentTypeReference
		(
			','
			ruleJvmArgumentTypeReference
		)*
		'>'
		(
			(
				('.'
				)=>
				'.'
			)
			ruleValidID
			(
				(
					('<')=>
					'<'
				)
				ruleJvmArgumentTypeReference
				(
					','
					ruleJvmArgumentTypeReference
				)*
				'>'
			)?
		)*
	)?
;

// Rule JvmArgumentTypeReference
ruleJvmArgumentTypeReference:
	(
		ruleJvmTypeReference
		    |
		ruleJvmWildcardTypeReference
	)
;

// Rule JvmWildcardTypeReference
ruleJvmWildcardTypeReference:
	'?'
	(
		ruleJvmUpperBound
		ruleJvmUpperBoundAnded
		*
		    |
		ruleJvmLowerBound
		ruleJvmLowerBoundAnded
		*
	)?
;

// Rule JvmUpperBound
ruleJvmUpperBound:
	'extends'
	ruleJvmTypeReference
;

// Rule JvmUpperBoundAnded
ruleJvmUpperBoundAnded:
	'&'
	ruleJvmTypeReference
;

// Rule JvmLowerBound
ruleJvmLowerBound:
	'super'
	ruleJvmTypeReference
;

// Rule JvmLowerBoundAnded
ruleJvmLowerBoundAnded:
	'&'
	ruleJvmTypeReference
;

// Rule QualifiedName
ruleQualifiedName:
	ruleValidID
	(
		'.'
		ruleValidID
	)*
;

// Rule QualifiedNameWithWildcard
ruleQualifiedNameWithWildcard:
	ruleQualifiedName
	'.'
	'*'
;

// Rule ValidID
ruleValidID:
	RULE_ID
;

// Rule XImportDeclaration
ruleXImportDeclaration:
	'import'
	(
		'static'
		'extension'
		?
		ruleQualifiedNameInStaticImport
		(
			'*'
			    |
			ruleValidID
		)
		    |
		ruleQualifiedName
		    |
		ruleQualifiedNameWithWildcard
	)
	';'?
;

RULE_INT : ('0'..'9')+;

RULE_ID : '^'? ('a'..'z'|'A'..'Z'|'$'|'_') ('a'..'z'|'A'..'Z'|'$'|'_'|'0'..'9')*;

RULE_STRING : ('"' ('\\' .|~(('\\'|'"')))* '"'?|'\'' ('\\' .|~(('\\'|'\'')))* '\''?);

RULE_ML_COMMENT : '/*' ( options {greedy=false;} : . )*'*/' {skip();};

RULE_SL_COMMENT : '//' ~(('\n'|'\r'))* ('\r'? '\n')? {skip();};

RULE_WS : (' '|'\t'|'\r'|'\n')+ {skip();};

RULE_ANY_OTHER : .;
